Index: libabac/abac_term.h
===================================================================
--- libabac/abac_term.h	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
+++ libabac/abac_term.h	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -0,0 +1,33 @@
+#ifndef __ABAC_TERM_H__
+#define __ABAC_TERM_H__
+
+#include "abac_defines.h"
+#include "abac_list.h"
+
+/* exported */
+/* for abac_aspect */
+extern char *abac_term_type_name(abac_term_t*);
+extern abac_condition_t *abac_term_constraint(abac_term_t*);
+extern abac_param_list_t *abac_param_list_new(abac_term_t *);
+extern char* abac_time_to_term(char*);
+extern char* abac_param_list_string_with_condition(abac_param_list_t *);
+extern char* abac_param_list_typed_string_with_condition(abac_param_list_t *);
+extern char* abac_param_list_string(abac_param_list_t *ptr);
+extern abac_list_t *abac_condition_range_list(abac_condition_t *ptr);
+extern int abac_item_type(abac_item_t *);
+extern char *abac_item_val(abac_item_t *);
+extern char *abac_term_to_time(char *);
+extern abac_aspect_t *abac_condition_of_aspect(abac_condition_t *ptr);
+extern abac_list_t *abac_param_list(abac_param_list_t *ptr);
+extern abac_term_t *abac_term_named_new(int idtype, char *name);
+extern char *abac_term_name(abac_term_t *term);
+extern abac_term_t *abac_term_new(int type, char *name, int isrange, char *cond, void *cptr);
+extern abac_aspect_t *abac_aspect_oset_new(char *principal_name, char *oset_name);
+extern abac_aspect_t *abac_aspect_role_new(char *principal_name, char *oset_name);
+extern abac_item_t *abac_item_new(int itype, char *val);
+
+extern abac_term_t *abac_term_copy(abac_term_t *);
+extern abac_param_list_t *abac_param_list_copy(abac_param_list_t *);
+
+
+#endif /* __ABAC_TERM_H__ */
Index: libabac/abac_util.c
===================================================================
--- libabac/abac_util.c	(revision 4f40c3e6cf53f7c95a2a544455682c85f601e846)
+++ libabac/abac_util.c	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -1,7 +1,5 @@
-
 /**
 ** abac_util.c
 **/
-
 #include <err.h>
 #include <stdlib.h>
@@ -13,4 +11,9 @@
 #include <termios.h>
 #include <unistd.h>
+#include <sys/types.h>
+
+#include <credentials/certificates/certificate.h>
+#include <credentials/certificates/x509.h>
+#include <credentials/keys/private_key.h>
 
 #include "abac_util.h"
@@ -20,21 +23,28 @@
 /* Callback configuration */
 struct cb_opts {
-    int use_prompt;    /* Print a prompt to stderr */
-    int use_echo;      /* If true, turn off input echo on stdin */
-    unsigned int tries; /* Number of attempts allowed */
-    char prompt[20];    /* The prompt to display if use_echo is true */
+    int use_prompt;                   /* Print a prompt to stderr */
+    int use_echo;        /* If true, turn off input echo on stdin */
+    unsigned int tries;             /* Number of attempts allowed */
+    char prompt[20]; /* The prompt to display if use_echo is true */
 };
 
-
+/**  potato pw length */
+#define PWLEN 128
+
+/** SHA string length */
 #define SHA1_LENGTH 40
-#ifndef ABAC_VERSION
-#define ABAC_VERSION "0.2.3"
-#endif
-
+
+/****************************************************************/
 char *abac_version()
 {
-   if(debug)
-       fprintf(stderr,"abac_version is %s\n", ABAC_VERSION);
+   DEBUG_PRINTF("abac_version is %s\n", ABAC_VERSION);
    return ABAC_VERSION;
+}
+
+char *prologIt(char *str)
+{
+    char *tmp=NULL;
+    asprintf(&tmp,"p%s",str);
+    return tmp;
 }
 
@@ -175,6 +185,5 @@
     rng->destroy(rng);
 
-    if(debug)
-        fprintf(stderr,"abac_generate_serial, serial generated is %#B\n", &serial);
+    DEBUG_PRINTF("abac_generate_serial, serial generated is %#B\n", &serial);
     return serial;
 }
@@ -275,5 +284,5 @@
    chunk_t pp=chunk_empty;
    if(file_exist(filename)) {
-       if(debug) fprintf(stderr,"trying to open %s\n", filename);
+       DEBUG_PRINTF("trying to open %s\n", filename);
        FILE *fp=fopen(filename,"r");
        char str[PWLEN]; 
Index: libabac/abac_util.h
===================================================================
--- libabac/abac_util.h	(revision 4f40c3e6cf53f7c95a2a544455682c85f601e846)
+++ libabac/abac_util.h	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -1,33 +1,35 @@
-#ifndef __UTIL_H__
-#define __UTTL_H__
+#ifndef __ABAC_UTIL_H__
+#define __ABAC_UTIL_H__
 
 #include <sys/types.h>
 
-#include <credentials/certificates/certificate.h>
-#include <credentials/certificates/x509.h>
-#include <credentials/keys/private_key.h>
-
 #include <chunk.h>
 
-#define PWLEN 128
-
-void *abac_xmalloc(size_t size);
-void *abac_xrealloc(void *ptr, size_t size);
-char *abac_xstrdup(char *source);
-char *abac_trim_quotes(char *string);
-void abac_split(char *string, char *delim, char **ret, int *num);
-int abac_validate_clean_name(char *string);
-int abac_validate_clean_aspect_name(char *string);
-chunk_t abac_generate_serial();
-void abac_clean_string(char *);
-
-int file_exist(char *filename);
-chunk_t extract_potato(char *filename, char *pfile);
+#ifndef ABAC_VERSION
+#define ABAC_VERSION "0.2.4"
+#endif
 
 #ifdef DEBUG
-#define debug_printf(...) fprintf(stderr, __VA_ARGS__)
+#define DEBUG_PRINTF(...) {if(debug) fprintf(stderr, __VA_ARGS__); }
 #else
-#define debug_printf(...) do { } while (0)
+#define DEBUG_PRINTF(...) {/*no op*/}
 #endif
 
-#endif /* __UTIL_H__ */
+/* exported from abac_util */
+extern char *abac_version();
+extern char *prologIt(char *);
+extern void *abac_xmalloc(size_t);
+extern void *abac_xrealloc(void*,size_t);
+extern char *abac_xstrdup(char*);
+extern char *abac_trim_quotes(char*);
+extern void abac_split(char*, char*, char**, int*);
+extern int abac_validate_clean_name(char*);
+extern int abac_validate_clean_aspect_name(char*);
+extern chunk_t abac_generate_serial();
+extern void abac_clean_string(char *);
+
+extern int file_exist(char*);
+extern chunk_t extract_potato(char*, char*);
+extern void abac_errx(int eval, const char *msg);
+
+#endif /* __ABAC_UTIL_H__ */
Index: libabac/abac_util_cert.c
===================================================================
--- libabac/abac_util_cert.c	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
+++ libabac/abac_util_cert.c	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -0,0 +1,86 @@
+/**
+** abac_util_cert.c
+** utility code related process/handling of certificate_t
+**/
+#include <err.h>
+#include <stdlib.h>
+#include <string.h>
+#include <stdio.h>
+#include <assert.h>
+#include <stdarg.h>
+#include <sys/stat.h>
+#include <termios.h>
+#include <unistd.h>
+#include <sys/types.h>
+
+#include <credentials/certificates/certificate.h>
+#include <credentials/certificates/x509.h>
+#include <credentials/keys/private_key.h>
+
+#include "abac_util.h"
+
+static int debug=0;
+
+char *cert_get_keyid(certificate_t *cert) {
+    // get the keyid
+    x509_t *x509 = (x509_t *)cert;
+    chunk_t keyid = x509->get_subjectKeyIdentifier(x509);
+    chunk_t string = chunk_to_hex(keyid, NULL, 0);
+    return (char *)string.ptr;
+}
+
+certificate_t *cert_get_id_cert_from_file(char *filename)
+{
+    certificate_t *cert = lib->creds->create(lib->creds,
+        CRED_CERTIFICATE, CERT_X509,
+        BUILD_FROM_FILE, filename,
+        BUILD_X509_FLAG, X509_AA, // attribute authority, dumb
+        BUILD_END
+    );
+    return cert;
+}
+
+certificate_t *cert_get_id_cert_from_chunk(chunk_t chunk)
+{
+    certificate_t *cert = lib->creds->create(lib->creds,
+        CRED_CERTIFICATE, CERT_X509,
+        BUILD_BLOB_ASN1_DER, chunk,
+        BUILD_X509_FLAG, X509_AA,
+        BUILD_END
+    );
+    return cert;
+}
+
+certificate_t *cert_get_id_cert_from_pem_chunk(chunk_t chunk)
+{
+    certificate_t *cert = lib->creds->create(lib->creds,
+        CRED_CERTIFICATE, CERT_X509,
+        BUILD_BLOB_PEM, chunk,
+        BUILD_X509_FLAG, X509_AA,
+        BUILD_END
+    );
+    return cert;
+}
+
+certificate_t *cert_get_attr_cert_from_file(char *filename)
+{
+    certificate_t *cert = lib->creds->create(lib->creds,
+        CRED_CERTIFICATE, CERT_X509_AC,
+        BUILD_FROM_FILE, filename,
+        BUILD_END
+    );
+    return cert;
+}
+
+
+certificate_t *cert_get_attr_cert_from_chunk(chunk_t chunk)
+{
+    certificate_t *cert = lib->creds->create(lib->creds,
+        CRED_CERTIFICATE, CERT_X509_AC,
+        BUILD_BLOB_ASN1_DER, chunk,
+        BUILD_END
+    );
+    return cert;
+}
+
+
Index: libabac/abac_util_cert.h
===================================================================
--- libabac/abac_util_cert.h	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
+++ libabac/abac_util_cert.h	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -0,0 +1,17 @@
+#ifndef __ABAC_CERT_UTIL_H__
+#define __ABAC_CERT_UTIL_H__
+
+#include <sys/types.h>
+
+#include <credentials/certificates/certificate.h>
+#include <credentials/certificates/x509.h>
+#include <credentials/keys/private_key.h>
+
+extern char *cert_get_keyid(certificate_t *cert);
+extern certificate_t *cert_get_id_cert_from_file(char *filename);
+extern certificate_t *cert_get_id_cert_from_chunk(chunk_t chunk);
+extern certificate_t *cert_get_id_cert_from_pem_chunk(chunk_t chunk);
+extern certificate_t *cert_get_attr_cert_from_file(char *filename);
+extern certificate_t *cert_get_attr_cert_from_chunk(chunk_t chunk);
+
+#endif /* __ABAC_CERT_UTIL_H__ */
